//
//					addsubmovneg8a.v - 8-bit adder/subtracter
//
//					(C) Copyright 2004-2009 John B. Stephensen
//
// This Verilog source file and all its derivatives are licensed only for
// personal non-profit educational use in the Amateur Radio Service and
// the license is not transferrable. The information is provided as-is for
// experimental purposes and the author does not warranty its freedom
// from defects or its suitability for any specific application.
//
//	ENA SUB Desc.
//  0   0  Y = B + CI
//	 0   1  Y = ~B + CI
//	 1   0  Y = A + B + CI
//	 1   1  Y = A + ~B + CI
//
// 4 slices used.
//
module addsubmovneg8a(
    input SUB,
    input ENA,
    input [7:0] A,
    input [7:0] B,
    input CI,
    output CO,
    output [7:0] Y
    );
// internal signals
wire [6:0] c;	// carry propogation
// use 8 one-bit adders
addsubmovneg1a a7 (.SUB(SUB), .ENA(ENA), .A(A[7]), .B(B[7]), .CI(c[6]), .CO(CO), .Y(Y[7]));
addsubmovneg1a a6 (.SUB(SUB), .ENA(ENA), .A(A[6]), .B(B[6]), .CI(c[5]), .CO(c[6]), .Y(Y[6]));
addsubmovneg1a a5 (.SUB(SUB), .ENA(ENA), .A(A[5]), .B(B[5]), .CI(c[4]), .CO(c[5]), .Y(Y[5]));
addsubmovneg1a a4 (.SUB(SUB), .ENA(ENA), .A(A[4]), .B(B[4]), .CI(c[3]), .CO(c[4]), .Y(Y[4]));
addsubmovneg1a a3 (.SUB(SUB), .ENA(ENA), .A(A[3]), .B(B[3]), .CI(c[2]), .CO(c[3]), .Y(Y[3]));
addsubmovneg1a a2 (.SUB(SUB), .ENA(ENA), .A(A[2]), .B(B[2]), .CI(c[1]), .CO(c[2]), .Y(Y[2]));
addsubmovneg1a a1 (.SUB(SUB), .ENA(ENA), .A(A[1]), .B(B[1]), .CI(c[0]), .CO(c[1]), .Y(Y[1]));
addsubmovneg1a a0 (.SUB(SUB), .ENA(ENA), .A(A[0]), .B(B[0]), .CI(CI), .CO(c[0]), .Y(Y[0]));
endmodule
